unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SHDocVW_TLB, MSHTML_TLB, ActiveX, OleCtrls, SHDocVw, StdCtrls;

type
  TForm1 = class(TForm)
    SourceView: TMemo;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;


const
  RSPSIMPLESERVICE     = 1;
  RSPUNREGISTERSERVICE = 0;

implementation

{$R *.dfm}


type
TObjectFromLResult = function(LRESULT: lResult; const IID: TIID; WPARAM: wParam; out pObject): HRESULT; stdcall;

//This function detects the Window
function GetIEFromHWND(WHandle: HWND; var IE: IWebbrowser2): HRESULT;
var
  hInst: HWND;
  lRes: Cardinal;
  MSG: Integer;
  pDoc: IHTMLDocument2;
  ObjectFromLresult: TObjectFromLresult;
begin
  hInst := LoadLibrary('Oleacc.dll');
  @ObjectFromLresult := GetProcAddress(hInst, 'ObjectFromLresult');
  if @ObjectFromLresult <> nil then begin
    try
      MSG := RegisterWindowMessage('WM_HTML_GETOBJECT');
      SendMessageTimeOut(WHandle, MSG, 0, 0, SMTO_ABORTIFHUNG, 1000, lRes);
      Result := ObjectFromLresult(lRes, IHTMLDocument2, 0, pDoc);
      if Result = S_OK then
        (pDoc.parentWindow as IServiceprovider).QueryService(IWebbrowserApp, IWebbrowser2, IE);
    finally
      FreeLibrary(hInst);
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
        All: IHtmlElementCollection;
        HtmlElement: IHtmlElement;
        I: Integer;
        Document: IHtmlDocument2;
        IE: IWebBrowser2;
        Wnd: HWND;
        WndChild: HWND;
begin
        Wnd := FindWindow('IEFrame', nil);
        if Wnd = 0 then
        begin
             MessageDlg ('No Running instance of Internet Explorer!',mtError, [mbOK], 0);
        end;
// walk Shell DocObject View->Internet Explorer_Server
        WndChild := FindWindowEX(Wnd, 0, 'Shell DocObject View', nil);
        if WndChild <> 0 then begin
         WndChild := FindWindowEX(WndChild, 0, 'Internet Explorer_Server', nil);
        if WndChild <> 0 then
        begin
                GetIEFromHWnd(WndChild, IE); //Get Iwebbrowser2 from Handle
                Document := IE.Document as IHtmlDocument2;
                if (assigned(Document)) then
                begin
                        All := Document.All;
                        for I := 0 to All.Length -1 do
                        begin
                                HtmlElement := All.item(i,0) as IhtmlElement;
                                if (assigned(Document)) then
                              SourceView.Lines.Add (IntToStr(i) + ' ' + HTmlElement.innerHTML);
                        end;
               end;
          end;
      end;
end;

end.
